#ifndef USE_OSS
#define USE_OSS

#include <sys/soundcard.h> /* z.B. audio_buf_info typedef */
#include <sys/ioctl.h>

#include <signal.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <errno.h>

#include <stdlib.h> /* abort, exit */
#include <stdio.h>
// #include <string.h>
#include <fcntl.h>
#include <unistd.h> /* fork(), read, write, close... */

#define HZ 100 /* zur Zeitmessung */
// #define SNDusesTIMER 0 /* default bei Oxl ist aus (-ossptr) */
#define NUMFRAGS 32
#define FRAGSIZE 2048

#define SampRate 22050
#define ByPerSamp 2 /* 1 oder 2, 1 for 8 bit seems to be deprecated? */
#define SOUND16BIT 1 /* undefine for 8 bit sound */
#define StereoChn 1 /* 1 oder 2, 1 for mono seems to be deprecated? */

void signalbehandler(); // Signalbehandlung aktivieren

int gettime(); // in Takten ab 1. Aufruf gemessen, jede Sekunde hat HZ Takte
               // regelmaessig nach oss_forkplayer rufen, damit der
               // Childprozess ein Lebenszeichen vom Parentprozess hat!!

#define OSS_FILE "/dev/dsp"
// #define OSS_FILE "/dev/dsp1"
void oss_open();
void oss_close();
void oss_send(void * buffer, int length);
// Wrapper fuer write zu /dev/dsp

void oss_fillbuffer(void(*player)()); 
// ruft sooft player, bis ioctl noch <1/2 Fragmente frei im Puffer meldet
void oss_forkplayer(void(*player)());
// startet eine Endlosschleife fuer den Player 
// (der irgendwann blockieren sollte, bis wieder Platz in Audiobuffer ist)

#endif
