#ifndef EA_TYPEN
#define EA_TYPEN

#define PI2 (M_PI + M_PI)
#define PI M_PI

#include <stdio.h>

#ifdef __linux__
#include <linux/string.h>
#else
#include <string.h>
#endif
// Linux-Version der Stringfunktionen ist besser optimiert!

#include <sys/time.h>
/* #include <unistd.h> */
#include <malloc.h> 
/* neben atoi, [at]exit, getenv  etc. ist malloc auch in stdlib.h def. */

// #ifdef __linux__
// #include <linux/random.h>
// #else
// #include <stdlib.h>    /* nur wegen random, hrmpf... */
// #endif
#define RAND_MAX  2147483647

#include <math.h>

#ifndef minimum
#define minimum(a,b) (((a) < (b)) ? (a) : (b))
#endif
#ifndef maximum
#define maximum(a,b) (((a) > (b)) ? (a) : (b))
#endif


/* ----------------------------------------------------------------- */

#if 0
__inline__ extern int CLIP2BYTE(int x)
{ register int res;
  __asm__ __volatile__
  ("cmpl $255,%%eax"
   "jl 1f # wenn x < 255 ist ... der Assembler 'as' schreibt cmp so herum!"
   "movl $255,%%eax"
   "jmp 2f"
 "1: testl %%eax,%%eax"
   "jnl 2f"
   "xorl %%eax,%%eax"
 "2: nop"
   ":=a(res):0(x)");
  return res;
};
#endif
#define CLIP2BYTE(x) ((x<0) ? 0 : ((x>255) ? 255 : x))

__inline__ extern int CLIPFLOAT2BYTE(double x)
{ register int res;
  __asm__ __volatile__
  ("pushl %%eax"
   "fistl (%%esp) # kein p(op), da GCC glaubt, 't' selber poppen zu muessen!"
   "popl %%eax"
   "cmpl $255,%%eax"
   "jl 1f # wenn x < 255 ist ... der Assembler 'as' schreibt cmp so herum!"
   "movl $255,%%eax"
   "jmp 2f"
 "1: testl %%eax,%%eax"
   "jnl 2f"
   "xorl %%eax,%%eax"
 "2: nop"
   ":=a(res):t(x)");
  return res;
};

/* ----------------------------------------------------------------- */

static int seed = 42;

#if 0
__inline__ extern int RippedRandom() // ECHTES INLINE!
{
  register int res=0;
  __asm__ __volatile__
  ("imull $0x41c64e6d,(%%ecx),%%eax"
   "addl  $0x3039,%%eax"
   "andl  $0x7fffffff,%%eax"
   "movl  %%eax,(%%ecx)"
   ":=a(res):c(&seed)");
  return res;
#endif
static int RippedRandom()
{
  seed = (seed * 0x41c64e6d) + 0x3039;
  return seed & 0x7fffffff;
};

#if 0
__inline__ extern int myRND(int min, int max) // SO GEHT INLINE!
{
  register int res=0;
  __asm__ __volatile__
  ("movl  (%%ecx),%%ecx"
   "imull $0x41c64e6d,(%%ecx),%%eax"
   "addl  $0x3039,%%eax"
   "andl  $0x7fffffff,%%eax"
   "movl  %%eax,(%%ecx)"
   "subl  %%edx,%%ebx"
   "pushl %%edx"
   "xorl  %%edx,%%edx"
   "idiv  %%ebx # Rest kommt nach EDX"
   "popl  %%eax"
   "addl  %%edx,%%eax"
   ":=a(res):d(min):b(max+1):c(&seed)");
   return res;               // verwendet ein unnoetiges Register "res",
   // aber ich konnte gcc nicht erklaeren, dass eax zu return-en ist *8(
#endif
static int myRND(int min, int max)
{
   return (RippedRandom() % (max+1-min))+min;
};

// #define randomize srand(time(NULL))
// rand/srand sind ANSI, random/srandom sind BSD... RAND_MAX ist
// uebrigens etwa 2.000.000.000 und der Zufallsgenerator 
// richtig komplex mit 8-256 Bytes(?) im "Statusbuffer" !??
// #define rnd(min,max) ( ( Xrandom() % (1 + (max)-(min)) ) + (min) )

#define randomize seed = time(NULL) /* oder srand(time(NULL)) */
#define Xrandom RippedRandom /* oder random */
#define rnd myRND
#define frnd(min,max) ( (min)+( ((max) - (min)) * ((0.0+Xrandom()) / RAND_MAX) )
#define ENIT (-1) /* PS: abort() dumps core ;-) */

#define round rint
// sehr witzig, erst mal draufkommen... "rint"  ... floor(a+.5) ... -> float

// Billigvariante: round2int(a) als ((int)(a)) statt als (int)round(a)
// Aber schneller ist die ASM in typen.c ...
// rint ist eine Funktion und kein FPU-Assemblerbefehl :-(.
// Assembler: frndint (f->f): round to int / fist (f->i): save int part to mem
// rint / floor / ceil sind alle double->double
// PS: abs (int->int!) / fabs (double->double) / labs (long int->long int)

typedef signed char shortint;
typedef unsigned char byte;
typedef signed short int integer; /* 16 Bit, Pascal-DOSig */
typedef unsigned short int word;
typedef signed int longint;       /* auch DOSig */
typedef unsigned int dword;

typedef unsigned char boolean;
typedef float real;
typedef long double extended;

#define round2int_inline(i,f) __asm__ \
  ("pushl %%eax; fistl (%%esp); popl %%eax":"=a"(i):"t"(f) )
  
#if 0
__inline__ extern int round2int(const double f)
{ register int i;
  __asm__ __volatile__
  ( "pushl %%eax; fistl (%%esp); popl %%eax" : "=a"(i) : "t"(f) );
  return i;
};
#endif
static int round2int(const double f)
{
  return (int)round(f);
}


#endif
